﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.RadControlSpy;
using Telerik.WinControls.UI;

namespace _940647_RadGridViewCellPainting
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            new RadControlSpyForm().Show();

            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("Id", typeof(int));
            dataTable.Columns.Add("Name", typeof(string));
            dataTable.Columns.Add("IsValid", typeof(bool));
            dataTable.Columns.Add("Date", typeof(DateTime));

            for (int i = 0; i < 100; i++)
            {
                dataTable.Rows.Add(i, "Name " + i, i % 2 == 0 ? true : false, DateTime.Now.AddDays(i));
            }

            this.radGridView1.DataSource = dataTable;
            this.radGridView1.CellFormatting += radGridView1_CellFormatting;
            this.radGridView1.RowFormatting += radGridView1_RowFormatting;
            this.radGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;
        }

        private void radGridView1_CellFormatting(object sender, CellFormattingEventArgs e)
        {
            if (e.CellElement.IsCurrent)
            {
                e.CellElement.GradientStyle = e.CellElement.RowElement.GradientStyle;
                e.CellElement.BackColor = e.CellElement.RowElement.BackColor;
                e.CellElement.ForeColor = e.CellElement.RowElement.ForeColor;
            }
            else
            {
                e.CellElement.ResetValue(LightVisualElement.BackColorProperty, ValueResetFlags.Local);
                e.CellElement.ResetValue(LightVisualElement.GradientStyleProperty, ValueResetFlags.Local);
                e.CellElement.ResetValue(LightVisualElement.DrawFillProperty, ValueResetFlags.Local);
                e.CellElement.ResetValue(LightVisualElement.ForeColorProperty, ValueResetFlags.Local);
            }
        }

        private void radGridView1_RowFormatting(object sender, RowFormattingEventArgs e)
        {
            GridRowElement rowElement = e.RowElement;
            if (rowElement.RowInfo.Cells[2].Value.Equals(true))
            {
                rowElement.DrawFill = true;
                rowElement.GradientStyle = GradientStyles.Solid;
                rowElement.BackColor = Color.Gray;
                rowElement.ForeColor = Color.White;
            }
            else
            {
                rowElement.ResetValue(LightVisualElement.BackColorProperty, ValueResetFlags.Local);
                rowElement.ResetValue(LightVisualElement.GradientStyleProperty, ValueResetFlags.Local);
                rowElement.ResetValue(LightVisualElement.DrawFillProperty, ValueResetFlags.Local);
                rowElement.ResetValue(LightVisualElement.ForeColorProperty, ValueResetFlags.Local);
            }
        }
    }
}
